<?php

if (!in_array($_POST['algo'], ['8', '13', '14', '15', '16'], true))
	output(403, 'Wrong value for <code>algo</code>.');

$_POST['keytag'] = intval($_POST['keytag']);
if ((preg_match('/^[0-9]{1,6}$/D', $_POST['keytag'])) !== 1 OR !($_POST['keytag'] >= 1) OR !($_POST['keytag'] <= 65535))
	output(403, 'Wrong value for <code>keytag</code>.');

if ($_POST['dt'] !== '2' AND $_POST['dt'] !== '4')
	output(403, 'Wrong value for <code>dt</code>.');

if (preg_match('/^(?:[0-9a-fA-F]{64}|[0-9a-fA-F]{96})$/D', $_POST['key']) !== 1)
	output(403, 'Wrong value for <code>key</code>.');

regCheckDomainPossession($_POST['zone']);

rateLimit();

knotcZoneExec(regParseDomain($_POST['zone'])['suffix'], [
	$_POST['zone'],
	CONF['reg']['ttl'],
	'DS',
	$_POST['keytag'],
	$_POST['algo'],
	$_POST['dt'],
	$_POST['key']
]);

output(200, _('Modification done.'));
